## wxRadioBox

A radio box item is used to select one of number of mutually exclusive choices. It is displayed as a vertical column or horizontal row of labelled buttons.

Derived from

wxControlWithItems
wxControl
wxWindow
wxEvtHandler
wxObject

Include files

<wx/radiobox.h>

Window styles

wxRA_SPECIFY_ROWS | The major dimension parameter refers to the maximum number of rows.
wxRA_SPECIFY_COLS | The major dimension parameter refers to the maximum number of columns.
wxRA_USE_CHECKBOX | Use of the checkbox controls instead of radio buttons (currently supported only on PalmOS)

See also window styles overview.

Event handling

EVT_RADIOBOX(id, func) | Process a wxEVT_COMMAND_RADIOBOX_SELECTED event, when a radiobutton is clicked.

See also

Event handling overview, wxRadioButton, wxCheckBox

Members

wxRadioBox::wxRadioBox
wxRadioBox::~wxRadioBox
wxRadioBox::Create
wxRadioBox::Enable
wxRadioBox::FindString
wxRadioBox::GetColumnCount
wxRadioBox::GetItemHelpText
wxRadioBox::GetItemToolTip
wxRadioBox::GetItemFromPoint
wxRadioBox::GetLabel
wxRadioBox::GetRowCount
wxRadioBox::GetSelection
wxRadioBox::GetStringSelection
wxRadioBox::GetString
wxRadioBox::IsItemEnabled
wxRadioBox::IsItemShown
wxRadioBox::SetItemHelpText
wxRadioBox::SetLabel
wxRadioBox::SetSelection
wxRadioBox::SetStringSelection
wxRadioBox::SetItemToolTip
wxRadioBox::Show

### wxRadioBox::wxRadioBox

wxRadioBox()

Default constructor.

wxRadioBox(wxWindow* parent, wxWindowID id, const wxString& label, const wxPoint& point = wxDefaultPosition, const wxSize& size = wxDefaultSize, int n = 0, const wxString choices[] = NULL, int majorDimension = 0, long style = wxRA_SPECIFY_COLS, const wxValidator& validator = wxDefaultValidator, const wxString& name = "radioBox")

wxRadioBox(wxWindow* parent, wxWindowID id, const wxString& label, const wxPoint& point, const wxSize& size, const wxArrayString& choices, int majorDimension = 0, long style = wxRA_SPECIFY_COLS, const wxValidator& validator = wxDefaultValidator, const wxString& name = "radioBox")

Constructor, creating and showing a radiobox.

Parameters

parent

Parent window. Must not be NULL.

id

Window identifier. A value of -1 indicates a default value.

label

Label for the static box surrounding the radio buttons.

pos

Window position. If the position (-1, -1) is specified then a default position is chosen.

size

Window size. If the default size (-1, -1) is specified then a default size is chosen.

n

Number of choices with which to initialize the radiobox.

choices

An array of choices with which to initialize the radiobox.

majorDimension

Specifies the maximum number of rows (if style contains wxRA_SPECIFY_ROWS) or columns (if style contains wxRA_SPECIFY_COLS) for a two-dimensional radiobox.

style

Window style. See wxRadioBox.

validator

Window validator.

name

Window name.

See also

wxRadioBox::Create, wxValidator

wxPython note: The wxRadioBox constructor in wxPython reduces the `n` and `choices` arguments are to a single argument, which is a list of strings.

wxPerl note: In wxPerl there is just an array reference in place of `n` and `choices`.

### wxRadioBox::~wxRadioBox

~wxRadioBox()

Destructor, destroying the radiobox item.

### wxRadioBox::Create

bool Create(wxWindow* parent, wxWindowID id, const wxString& label, const wxPoint& point = wxDefaultPosition, const wxSize& size = wxDefaultSize, int n = 0, const wxString choices[] = NULL, int majorDimension = 0, long style = wxRA_SPECIFY_COLS, const wxValidator& validator = wxDefaultValidator, const wxString& name = "radioBox")

bool Create(wxWindow* parent, wxWindowID id, const wxString& label, const wxPoint& point, const wxSize& size, const wxArrayString& choices, int majorDimension = 0, long style = wxRA_SPECIFY_COLS, const wxValidator& validator = wxDefaultValidator, const wxString& name = "radioBox")

Creates the radiobox for two-step construction. See wxRadioBox::wxRadioBox for further details.

### wxRadioBox::Enable

virtual bool Enable(bool enable = `true`)

Enables or disables the entire radiobox.

virtual bool Enable(unsigned int n, bool enable = `true`)

Enables or disables an individual button in the radiobox.

Parameters

enable

true to enable, false to disable.

n

The zero-based button to enable or disable.

wxPython note: In place of a single overloaded method name, wxPython implements the following methods:

Enable(flag) | Enables or disables the entire radiobox.
EnableItem(n, flag) | Enables or disables an individual button in the radiobox.

See also

wxWindow::Enable

### wxRadioBox::FindString

int FindString(const wxString& string) const

Finds a button matching the given string, returning the position if found, or -1 if not found.

Parameters

string

The string to find.

### wxRadioBox::GetColumnCount

unsigned int GetColumnCount() const

Returns the number of columns in the radiobox.

### wxRadioBox::GetItemHelpText

wxString GetItemHelpText(unsigned int item) const

Returns the helptext associated with the specified item if any or `wxEmptyString`.

Parameters

item

The zero-based item index.

See also

SetItemHelpText

### wxRadioBox::GetItemToolTip

wxToolTip * GetItemToolTip(unsigned int item) const

Returns the tooltip associated with the specified item if any or `NULL`.

See also

SetItemToolTip,
wxWindow::GetToolTip

### wxRadioBox::GetItemFromPoint

int GetItemFromPoint(const wxPoint pt) const

Returns a radio box item under the point, a zero-based item index, or `wxNOT_FOUND` if no item is under the point.

pt

Point in client coordinates.

### wxRadioBox::GetLabel

wxString GetLabel() const

Returns the radiobox label.

Parameters

n

The zero-based button index.

See also

wxRadioBox::SetLabel

wxPython note: In place of a single overloaded method name, wxPython implements the following methods:

GetLabel() | Returns the radiobox label.
GetItemLabel(n) | Returns the label for the given button.

### wxRadioBox::GetRowCount

unsigned int GetRowCount() const

Returns the number of rows in the radiobox.

### wxRadioBox::GetSelection

int GetSelection() const

Returns the zero-based position of the selected button.

### wxRadioBox::GetStringSelection

wxString GetStringSelection() const

Returns the selected string.

### wxRadioBox::GetString

wxString GetString(unsigned int n) const

Returns the label for the button at the given position.

Parameters

n

The zero-based button position.

### wxRadioBox::IsItemEnabled

bool IsItemEnabled(unsigned int n) const

Returns `true` if the item is enabled or `false` if it was disabled using Enable(n, false).

Platform note: Currently only implemented in wxMSW, wxGTK and wxUniversal and always returns `true` in the other ports.

Parameters

n

The zero-based button position.

### wxRadioBox::IsItemShown

bool IsItemShown(unsigned int n) const

Returns `true` if the item is currently shown or `false` if it was hidden using Show(n, false).

Note that this function returns `true` for an item which hadn't been hidden even if the entire radiobox is not currently shown.

Platform note: Currently only implemented in wxMSW, wxGTK and wxUniversal and always returns `true` in the other ports.

Parameters

n

The zero-based button position.

### wxRadioBox::SetItemHelpText

void SetItemHelpText(unsigned int item, const wxString& helptext)

Sets the helptext for an item. Empty string erases any existing helptext.

Parameters

item

The zero-based item index.

helptext

The help text to set for the item.

See also

GetItemHelpText

### wxRadioBox::SetLabel

void SetLabel(const wxString& label)

Sets the radiobox label.

Parameters

label

The label to set.

n

The zero-based button index.

wxPython note: In place of a single overloaded method name, wxPython implements the following methods:

SetLabel(string) | Sets the radiobox label.
SetItemLabel(n, string) | Sets a label for a radio button.

### wxRadioBox::SetSelection

void SetSelection(int n)

Sets a button by passing the desired string position. This does not cause a wxEVT_COMMAND_RADIOBOX_SELECTED event to get emitted.

Parameters

n

The zero-based button position.

### wxRadioBox::SetStringSelection

void SetStringSelection(const wxString& string)

Sets the selection to a button by passing the desired string. This does not cause a wxEVT_COMMAND_RADIOBOX_SELECTED event to get emitted.

Parameters

string

The label of the button to select.

### wxRadioBox::SetItemToolTip

void SetItemToolTip(unsigned int item, const wxString& text)

Sets the tooltip text for the specified item in the radio group.

Platform note: Currently only implemented in wxMSW and wxGTK2 and does nothing in the other ports.

Parameters

item

Index of the item the tooltip will be shown for.

text

Tooltip text for the item, the tooltip is removed if empty.

See also

GetItemToolTip,
wxWindow::SetToolTip

### wxRadioBox::Show

virtual bool Show(const bool show = `true`)

Shows or hides the entire radiobox.

virtual bool Show(unsigned int item, const bool show = `true`)

Shows or hides individual buttons.

Parameters

show

true to show, false to hide.

item

The zero-based position of the button to show or hide.

Return value

`true` if the box or item has been shown or hidden or `false` if nothing was done because it already was in the requested state.

See also

wxWindow::Show

wxPython note: In place of a single overloaded method name, wxPython implements the following methods:

Show(flag) | Shows or hides the entire radiobox.
ShowItem(n, flag) | Shows or hides individual buttons.